
#include "pac_queue.h"

PQueue *pactos_queue_create()
{
	PQueue *new_queue = g_new(PQueue, 1);
	new_queue->elements = NULL;

	new_queue->q_mutex = g_new(pthread_mutex_t,1);
	pthread_mutex_init(new_queue->q_mutex, NULL);

	new_queue->q_condition = g_new(pthread_cond_t, 1);
	pthread_cond_init(new_queue->q_condition, NULL);

	return new_queue;	
}

void *pactos_queue_pop(PQueue *q)
{
	void *result = NULL;
	pthread_mutex_lock(q->q_mutex);
	
	while(q->elements == NULL)
	{
		pthread_cond_wait(q->q_condition, q->q_mutex);
	}

	result = q->elements->data;
	q->elements = g_slist_remove(q->elements, q->elements->data);

	pthread_cond_signal(q->q_condition);
	pthread_mutex_unlock(q->q_mutex);

	return result;
}

gboolean pactos_queue_push(PQueue *q, void *data)
{
	pthread_mutex_lock(q->q_mutex);
	
	q->elements = g_slist_append(q->elements, data);

	pthread_cond_signal(q->q_condition);
	pthread_mutex_unlock(q->q_mutex);

	return TRUE;
}

gboolean pactos_queue_clear(PQueue *q)
{
	pthread_mutex_lock(q->q_mutex);
	
	while(q->elements != NULL)
	{
		void *entry = q->elements->data;
		g_free(entry);
		q->elements = g_slist_remove(q->elements, q->elements->data);
	}

	q->elements = NULL;

	pthread_mutex_unlock(q->q_mutex);

	return TRUE;
} 


gboolean pactos_add_to_queue(PQueue *q, void *data)
{
	return TRUE;
}

gboolean pactos_delete_from_queue(PQueue *q, void *data)
{
	return TRUE;
}










