#ifndef PAC_LOGGER_H
#define PAC_LOGGER_H

#include <stdio.h>
#include <string.h>
#include <glib-2.0/glib.h>
#include <sys/time.h>

#define pac_log
#define pac_log_file "/home/pi/pactos_isolated.log"

#ifdef pac_log
	#define pac_debug TRUE
#else
	#define pac_debug FALSE
#endif

extern FILE *plog_file;

#define PAC_LOG(arg...) \
	if (pac_debug){ \
		time_t t; \
		struct timeval tv; \
		char *tstr; \
		t = time(NULL); \
		tstr = g_strdup(ctime(&t)); \
		tstr[strlen(tstr)-1] = 0; \
		gettimeofday(&tv,NULL); \
		fprintf(plog_file," %s [%d]",tstr, (int) tv.tv_usec); \
		fprintf(plog_file, ": "); \
		fprintf(plog_file, arg); \
		fprintf(plog_file, "\n"); \
		fflush(plog_file); \
		g_free(tstr); \
	}

gboolean pac_logger_init();

void pac_logger_close();

#endif //PAC_LOGGER_H
