#ifndef PAC_QUEUE_H
#define PAC_QUEUE_H

#include <glib-2.0/glib.h>
#include <pthread.h>

typedef struct {

	GSList *elements;
	pthread_mutex_t *q_mutex;
	pthread_cond_t *q_condition;

} PQueue;

PQueue *pactos_queue_create();
gboolean pactos_add_to_queue(PQueue *q, void *data);
gboolean pactos_delete_from_queue(PQueue *q, void *data);
gboolean pactos_queue_clear(PQueue *q);

void *pactos_queue_pop(PQueue *q);
gboolean pactos_queue_push(PQueue *q, void *data);

#endif // PAC_QUEUE_H
